a612358b3f3150b78808975310c823c326c88d0a
[osm/devops.git] / installers / full_install_osm.sh
1 #!/bin/bash
2 # Copyright 2016 Telefónica Investigación y Desarrollo S.A.U.
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 function usage(){
17 echo -e "usage: $0 [OPTIONS]"
18 echo -e "Install OSM from binaries or source code (by default, from binaries)"
19 echo -e " OPTIONS"
20 echo -e " -h / --help: print this help"
21 echo -e " -y: do not prompt for confirmation, assumes yes"
22 echo -e " -r <repo>: use specified repository name for osm packages"
23 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
24 echo -e " -u <repo base>: use specified repository url for osm packages"
25 echo -e " -k <repo key>: use specified repository public key url"
26 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
27 echo -e " -b master (main dev branch)"
28 echo -e " -b v2.0 (v2.0 branch)"
29 echo -e " -b tags/v1.1.0 (a specific tag)"
30 echo -e " ..."
31 echo -e " -c <orchestrator> deploy osm services using container <orchestrator>. Valid values are <k8s> or <swarm>. If -c is not used then osm will be deployed using default orchestrator. When used with --uninstall, osm services deployed by the orchestrator will be uninstalled"
32 echo -e " -s <stack name> or <namespace> user defined stack name when installed using swarm or namespace when installed using k8s, default is osm"
33 echo -e " -H <VCA host> use specific juju host controller IP"
34 echo -e " -S <VCA secret> use VCA/juju secret key"
35 echo -e " -P <VCA pubkey> use VCA/juju public key file"
36 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
37 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
38 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
39 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
40 echo -e " --pla: install the PLA module for placement support"
41 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
42 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, k8s_monitor)"
43 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
44 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
45 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
46 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
47 echo -e " -D <devops path> use local devops installation path"
48 echo -e " -w <work dir> Location to store runtime installation"
49 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
50 echo -e " -l: LXD cloud yaml file"
51 echo -e " -L: LXD credentials yaml file"
52 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
53 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
54 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
55 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
56 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
57 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
58 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
59 echo -e " --nojuju: do not juju, assumes already installed"
60 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
61 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
62 echo -e " --nohostclient: do not install the osmclient"
63 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
64 echo -e " --source: install OSM from source code using the latest stable tag"
65 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
66 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
67 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
68 echo -e " --volume: create a VM volume when installing to OpenStack"
69 # echo -e " --reconfigure: reconfigure the modules (DO NOT change NAT rules)"
70 # echo -e " --update: update to the latest stable release or to the latest commit if using a specific branch"
71 echo -e " --showopts: print chosen options and exit (only for debugging)"
72 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
73 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
74 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
75 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
76 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
77 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
78 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
79 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
80 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
81 echo -e " [--tag]: Docker image tag. (--charmed option)"
82 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
83
84 }
85
86 # takes a juju/accounts.yaml file and returns the password specific
87 # for a controller. I wrote this using only bash tools to minimize
88 # additions of other packages
89 function parse_juju_password {
90 password_file="${HOME}/.local/share/juju/accounts.yaml"
91 local controller_name=$1
92 local s='[[:space:]]*' w='[a-zA-Z0-9_-]*' fs=$(echo @|tr @ '\034')
93 sed -ne "s|^\($s\):|\1|" \
94 -e "s|^\($s\)\($w\)$s:$s[\"']\(.*\)[\"']$s\$|\1$fs\2$fs\3|p" \
95 -e "s|^\($s\)\($w\)$s:$s\(.*\)$s\$|\1$fs\2$fs\3|p" $password_file |
96 awk -F$fs -v controller=$controller_name '{
97 indent = length($1)/2;
98 vname[indent] = $2;
99 for (i in vname) {if (i > indent) {delete vname[i]}}
100 if (length($3) > 0) {
101 vn=""; for (i=0; i<indent; i++) {vn=(vn)(vname[i])("_")}
102 if (match(vn,controller) && match($2,"password")) {
103 printf("%s",$3);
104 }
105 }
106 }'
107 }
108
109 function generate_secret() {
110 head /dev/urandom | tr -dc A-Za-z0-9 | head -c 32
111 }
112
113 function remove_volumes() {
114 if [ -n "$KUBERNETES" ]; then
115 k8_volume=$1
116 echo "Removing ${k8_volume}"
117 $WORKDIR_SUDO rm -rf ${k8_volume}
118 else
119 stack=$1
120 volumes="mongo_db mon_db osm_packages ro_db pol_db prom_db ro"
121 for volume in $volumes; do
122 sg docker -c "docker volume rm ${stack}_${volume}"
123 done
124 fi
125 }
126
127 function remove_network() {
128 stack=$1
129 sg docker -c "docker network rm net${stack}"
130 }
131
132 function remove_iptables() {
133 stack=$1
134 if [ -z "$OSM_VCA_HOST" ]; then
135 OSM_VCA_HOST=`sg lxd -c "juju show-controller ${stack}"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
136 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
137 fi
138
139 if [ -z "$DEFAULT_IP" ]; then
140 DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
141 [ -z "$DEFAULT_IF" ] && DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
142 [ -z "$DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
143 DEFAULT_IP=`ip -o -4 a |grep ${DEFAULT_IF}|awk '{split($4,a,"/"); print a[1]}'`
144 [ -z "$DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
145 fi
146
147 if sudo iptables -t nat -C PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST; then
148 sudo iptables -t nat -D PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST
149 sudo netfilter-persistent save
150 fi
151 }
152
153 function remove_stack() {
154 stack=$1
155 if sg docker -c "docker stack ps ${stack}" ; then
156 echo -e "\nRemoving stack ${stack}" && sg docker -c "docker stack rm ${stack}"
157 COUNTER=0
158 result=1
159 while [ ${COUNTER} -lt 30 ]; do
160 result=$(sg docker -c "docker stack ps ${stack}" | wc -l)
161 #echo "Dockers running: $result"
162 if [ "${result}" == "0" ]; then
163 break
164 fi
165 let COUNTER=COUNTER+1
166 sleep 1
167 done
168 if [ "${result}" == "0" ]; then
169 echo "All dockers of the stack ${stack} were removed"
170 else
171 FATAL "Some dockers of the stack ${stack} could not be removed. Could not clean it."
172 fi
173 sleep 5
174 fi
175 }
176
177 #removes osm deployments and services
178 function remove_k8s_namespace() {
179 kubectl delete ns $1
180 }
181
182 #removes helm only if there is nothing deployed in helm
183 function remove_helm() {
184 if [ "$(helm ls -q)" == "" ] ; then
185 sudo helm reset --force
186 kubectl delete --namespace kube-system serviceaccount tiller
187 kubectl delete clusterrolebinding tiller-cluster-rule
188 sudo rm /usr/local/bin/helm
189 rm -rf $HOME/.helm
190 fi
191 }
192
193 function remove_crontab_job() {
194 crontab -l | grep -v '${OSM_DEVOPS}/installers/update-juju-lxc-images' | crontab -
195 }
196
197 #Uninstall osmclient
198 function uninstall_osmclient() {
199 sudo apt-get remove --purge -y python-osmclient
200 sudo apt-get remove --purge -y python3-osmclient
201 }
202
203 #Uninstall lightweight OSM: remove dockers
204 function uninstall_lightweight() {
205 if [ -n "$INSTALL_ONLY" ]; then
206 if [ -n "$INSTALL_ELK" ]; then
207 echo -e "\nUninstalling OSM ELK stack"
208 remove_stack osm_elk
209 $WORKDIR_SUDO rm -rf $OSM_DOCKER_WORK_DIR/osm_elk
210 fi
211 else
212 echo -e "\nUninstalling OSM"
213 if [ -n "$KUBERNETES" ]; then
214 if [ -n "$INSTALL_K8S_MONITOR" ]; then
215 # uninstall OSM MONITORING
216 uninstall_k8s_monitoring
217 fi
218 remove_k8s_namespace $OSM_STACK_NAME
219 else
220 remove_stack $OSM_STACK_NAME
221 remove_stack osm_elk
222 fi
223 echo "Now osm docker images and volumes will be deleted"
224 # TODO: clean-up of images should take into account if other tags were used for specific modules
225 newgrp docker << EONG
226 for module in ro lcm keystone nbi mon pol pla osmclient; do
227 docker image rm ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module}:${OSM_DOCKER_TAG}
228 done
229 EONG
230
231 sg docker -c "docker image rm ${DOCKER_REGISTRY_URL}${DOCKER_USER}/ng-ui:${OSM_DOCKER_TAG}"
232
233 if [ -n "$KUBERNETES" ]; then
234 OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
235 remove_volumes $OSM_NAMESPACE_VOL
236 else
237 remove_volumes $OSM_STACK_NAME
238 remove_network $OSM_STACK_NAME
239 [ -z "$CONTROLLER_NAME" ] && remove_iptables $OSM_STACK_NAME
240 fi
241 echo "Removing $OSM_DOCKER_WORK_DIR"
242 $WORKDIR_SUDO rm -rf $OSM_DOCKER_WORK_DIR
243 [ -z "$CONTROLLER_NAME" ] && sg lxd -c "juju kill-controller -t 0 -y $OSM_STACK_NAME"
244 fi
245 remove_crontab_job
246
247 # Cleanup Openstack installer venv
248 if [ -d "$OPENSTACK_PYTHON_VENV" ]; then
249 rm -r $OPENSTACK_PYTHON_VENV
250 fi
251
252 [ -z "$INSTALL_NOHOSTCLIENT" ] && uninstall_osmclient
253 echo "Some docker images will be kept in case they are used by other docker stacks"
254 echo "To remove them, just run 'docker image prune' in a terminal"
255 return 0
256 }
257
258 #Safe unattended install of iptables-persistent
259 function check_install_iptables_persistent(){
260 echo -e "\nChecking required packages: iptables-persistent"
261 if ! dpkg -l iptables-persistent &>/dev/null; then
262 echo -e " Not installed.\nInstalling iptables-persistent requires root privileges"
263 echo iptables-persistent iptables-persistent/autosave_v4 boolean true | sudo debconf-set-selections
264 echo iptables-persistent iptables-persistent/autosave_v6 boolean true | sudo debconf-set-selections
265 sudo apt-get -yq install iptables-persistent
266 fi
267 }
268
269 #Configure NAT rules, based on the current IP addresses of containers
270 function nat(){
271 check_install_iptables_persistent
272
273 echo -e "\nConfiguring NAT rules"
274 echo -e " Required root privileges"
275 sudo $OSM_DEVOPS/installers/nat_osm
276 }
277
278 function FATAL(){
279 echo "FATAL error: Cannot install OSM due to \"$1\""
280 exit 1
281 }
282
283 function update_juju_images(){
284 crontab -l | grep update-juju-lxc-images || (crontab -l 2>/dev/null; echo "0 4 * * 6 $USER ${OSM_DEVOPS}/installers/update-juju-lxc-images --xenial --bionic") | crontab -
285 ${OSM_DEVOPS}/installers/update-juju-lxc-images --xenial --bionic
286 }
287
288 function install_lxd() {
289 # Apply sysctl production values for optimal performance
290 sudo cp ${OSM_DEVOPS}/installers/60-lxd-production.conf /etc/sysctl.d/60-lxd-production.conf
291 sudo sysctl --system
292
293 # Install LXD snap
294 sudo apt-get remove --purge -y liblxc1 lxc-common lxcfs lxd lxd-client
295 sudo snap install lxd
296
297 # Configure LXD
298 sudo usermod -a -G lxd `whoami`
299 cat ${OSM_DEVOPS}/installers/lxd-preseed.conf | sed 's/^config: {}/config:\n core.https_address: '$DEFAULT_IP':8443/' | sg lxd -c "lxd init --preseed"
300 sg lxd -c "lxd waitready"
301 DEFAULT_INTERFACE=$(ip route list|awk '$1=="default" {print $5; exit}')
302 [ -z "$DEFAULT_INTERFACE" ] && DEFAULT_INTERFACE=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
303 DEFAULT_MTU=$(ip addr show $DEFAULT_INTERFACE | perl -ne 'if (/mtu\s(\d+)/) {print $1;}')
304 sg lxd -c "lxc profile device set default eth0 mtu $DEFAULT_MTU"
305 sg lxd -c "lxc network set lxdbr0 bridge.mtu $DEFAULT_MTU"
306 #sudo systemctl stop lxd-bridge
307 #sudo systemctl --system daemon-reload
308 #sudo systemctl enable lxd-bridge
309 #sudo systemctl start lxd-bridge
310 }
311
312 function ask_user(){
313 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
314 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
315 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
316 read -e -p "$1" USER_CONFIRMATION
317 while true ; do
318 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
319 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
320 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
321 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
322 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
323 done
324 }
325
326 function install_osmclient(){
327 CLIENT_RELEASE=${RELEASE#"-R "}
328 CLIENT_REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
329 CLIENT_REPOSITORY=${REPOSITORY#"-r "}
330 CLIENT_REPOSITORY_BASE=${REPOSITORY_BASE#"-u "}
331 key_location=$CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE/$CLIENT_REPOSITORY_KEY
332 curl $key_location | sudo apt-key add -
333 sudo add-apt-repository -y "deb [arch=amd64] $CLIENT_REPOSITORY_BASE/$CLIENT_RELEASE $CLIENT_REPOSITORY osmclient IM"
334 sudo apt-get update
335 sudo apt-get install -y python3-pip
336 sudo -H LC_ALL=C python3 -m pip install -U pip
337 sudo -H LC_ALL=C python3 -m pip install -U python-magic pyangbind verboselogs
338 sudo apt-get install -y python3-osm-im python3-osmclient
339 if [ -f /usr/lib/python3/dist-packages/osm_im/requirements.txt ]; then
340 python3 -m pip install -r /usr/lib/python3/dist-packages/osm_im/requirements.txt
341 fi
342 if [ -f /usr/lib/python3/dist-packages/osmclient/requirements.txt ]; then
343 sudo apt-get install -y libcurl4-openssl-dev libssl-dev
344 python3 -m pip install -r /usr/lib/python3/dist-packages/osmclient/requirements.txt
345 fi
346 #sed 's,OSM_SOL005=[^$]*,OSM_SOL005=True,' -i ${HOME}/.bashrc
347 #echo 'export OSM_HOSTNAME=localhost' >> ${HOME}/.bashrc
348 #echo 'export OSM_SOL005=True' >> ${HOME}/.bashrc
349 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_HOSTNAME=`lxc list | awk '($2=="SO-ub"){print $6}'`
350 [ -z "$INSTALL_LIGHTWEIGHT" ] && export OSM_RO_HOSTNAME=`lxc list | awk '($2=="RO"){print $6}'`
351 echo -e "\nOSM client installed"
352 if [ -z "$INSTALL_LIGHTWEIGHT" ]; then
353 echo -e "You might be interested in adding the following OSM client env variables to your .bashrc file:"
354 echo " export OSM_HOSTNAME=${OSM_HOSTNAME}"
355 echo " export OSM_RO_HOSTNAME=${OSM_RO_HOSTNAME}"
356 else
357 echo -e "OSM client assumes that OSM host is running in localhost (127.0.0.1)."
358 echo -e "In case you want to interact with a different OSM host, you will have to configure this env variable in your .bashrc file:"
359 echo " export OSM_HOSTNAME=<OSM_host>"
360 fi
361 return 0
362 }
363
364 function install_prometheus_nodeexporter(){
365 if (systemctl -q is-active node_exporter)
366 then
367 echo "Node Exporter is already running."
368 else
369 echo "Node Exporter is not active, installing..."
370 if getent passwd node_exporter > /dev/null 2>&1; then
371 echo "node_exporter user exists"
372 else
373 echo "Creating user node_exporter"
374 sudo useradd --no-create-home --shell /bin/false node_exporter
375 fi
376 wget -q https://github.com/prometheus/node_exporter/releases/download/v$PROMETHEUS_NODE_EXPORTER_TAG/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64.tar.gz -P /tmp/
377 sudo tar -C /tmp -xf /tmp/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64.tar.gz
378 sudo cp /tmp/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64/node_exporter /usr/local/bin
379 sudo chown node_exporter:node_exporter /usr/local/bin/node_exporter
380 sudo rm -rf /tmp/node_exporter-$PROMETHEUS_NODE_EXPORTER_TAG.linux-amd64*
381 sudo cp ${OSM_DEVOPS}/installers/docker/prometheus_exporters/node_exporter.service /etc/systemd/system/node_exporter.service
382 sudo systemctl daemon-reload
383 sudo systemctl restart node_exporter
384 sudo systemctl enable node_exporter
385 echo "Node Exporter has been activated in this host."
386 fi
387 return 0
388 }
389
390 function uninstall_prometheus_nodeexporter(){
391 sudo systemctl stop node_exporter
392 sudo systemctl disable node_exporter
393 sudo rm /etc/systemd/system/node_exporter.service
394 sudo systemctl daemon-reload
395 sudo userdel node_exporter
396 sudo rm /usr/local/bin/node_exporter
397 return 0
398 }
399
400 function install_docker_ce() {
401 # installs and configures Docker CE
402 echo "Installing Docker CE ..."
403 sudo apt-get -qq update
404 sudo apt-get install -y apt-transport-https ca-certificates software-properties-common
405 curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
406 sudo add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu $(lsb_release -cs) stable"
407 sudo apt-get -qq update
408 sudo apt-get install -y docker-ce
409 echo "Adding user to group 'docker'"
410 sudo groupadd -f docker
411 sudo usermod -aG docker $USER
412 sleep 2
413 sudo service docker restart
414 echo "... restarted Docker service"
415 if [ -n "${DOCKER_PROXY_URL}" ]; then
416 echo "Configuring docker proxy ..."
417 if [ -f /etc/docker/daemon.json ]; then
418 if grep -q registry-mirrors /etc/docker/daemon.json; then
419 sudo sed -i "s|registry-mirrors.*|registry-mirrors\": [\"${DOCKER_PROXY_URL}\"] |" /etc/docker/daemon.json
420 else
421 sudo sed -i "s|{|{\n \"registry-mirrors\": [\"${DOCKER_PROXY_URL}\"],|" /etc/docker/daemon.json
422 fi
423 else
424 sudo bash -c "cat << EOF > /etc/docker/daemon.json
425 {
426 \"registry-mirrors\": [\"${DOCKER_PROXY_URL}\"]
427 }
428 EOF"
429 fi
430 sudo systemctl daemon-reload
431 sudo service docker restart
432 echo "... restarted Docker service again"
433 fi
434 sg docker -c "docker version" || FATAL "Docker installation failed"
435 echo "... Docker CE installation done"
436 return 0
437 }
438
439 function install_docker_compose() {
440 # installs and configures docker-compose
441 echo "Installing Docker Compose ..."
442 sudo curl -L https://github.com/docker/compose/releases/download/1.18.0/docker-compose-`uname -s`-`uname -m` -o /usr/local/bin/docker-compose
443 sudo chmod +x /usr/local/bin/docker-compose
444 echo "... Docker Compose installation done"
445 }
446
447 function install_juju() {
448 echo "Installing juju"
449 sudo snap install juju --classic --channel=$JUJU_VERSION/stable
450 [[ ":$PATH": != *":/snap/bin:"* ]] && PATH="/snap/bin:${PATH}"
451 [ -n "$INSTALL_NOCACHELXDIMAGES" ] || update_juju_images
452 echo "Finished installation of juju"
453 return 0
454 }
455
456 function juju_createcontroller() {
457 if ! juju show-controller $OSM_STACK_NAME &> /dev/null; then
458 # Not found created, create the controller
459 sudo usermod -a -G lxd ${USER}
460 sg lxd -c "juju bootstrap --bootstrap-series=xenial --agent-version=$JUJU_AGENT_VERSION $OSM_VCA_CLOUDNAME $OSM_STACK_NAME"
461 fi
462 [ $(juju controllers | awk "/^${OSM_STACK_NAME}[\*| ]/{print $1}"|wc -l) -eq 1 ] || FATAL "Juju installation failed"
463 juju controller-config features=[k8s-operators]
464 }
465
466 function juju_addk8s() {
467 cat $HOME/.kube/config | juju add-k8s $OSM_VCA_K8S_CLOUDNAME --controller $OSM_STACK_NAME --storage openebs-hostpath
468 }
469
470 function juju_createcontroller_k8s(){
471 cat $HOME/.kube/config | juju add-k8s $OSM_VCA_K8S_CLOUDNAME --client
472 juju bootstrap $OSM_VCA_K8S_CLOUDNAME $OSM_STACK_NAME \
473 --config controller-service-type=loadbalancer \
474 --agent-version=$JUJU_AGENT_VERSION
475 }
476
477
478 function juju_addlxd_cloud(){
479 mkdir -p /tmp/.osm
480 OSM_VCA_CLOUDNAME="lxd-cloud"
481 LXDENDPOINT=$DEFAULT_IP
482 LXD_CLOUD=/tmp/.osm/lxd-cloud.yaml
483 LXD_CREDENTIALS=/tmp/.osm/lxd-credentials.yaml
484
485 cat << EOF > $LXD_CLOUD
486 clouds:
487 $OSM_VCA_CLOUDNAME:
488 type: lxd
489 auth-types: [certificate]
490 endpoint: "https://$LXDENDPOINT:8443"
491 config:
492 ssl-hostname-verification: false
493 EOF
494 openssl req -nodes -new -x509 -keyout /tmp/.osm/client.key -out /tmp/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
495 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
496 local client_cert=`cat /tmp/.osm/client.crt | sed 's/^/ /'`
497 local client_key=`cat /tmp/.osm/client.key | sed 's/^/ /'`
498
499 cat << EOF > $LXD_CREDENTIALS
500 credentials:
501 $OSM_VCA_CLOUDNAME:
502 lxd-cloud:
503 auth-type: certificate
504 server-cert: |
505 $server_cert
506 client-cert: |
507 $client_cert
508 client-key: |
509 $client_key
510 EOF
511 lxc config trust add local: /tmp/.osm/client.crt
512 juju add-cloud -c $OSM_STACK_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD --force
513 juju add-credential -c $OSM_STACK_NAME $OSM_VCA_CLOUDNAME -f $LXD_CREDENTIALS
514 sg lxd -c "lxd waitready"
515 juju controller-config features=[k8s-operators]
516 }
517
518
519 function juju_createproxy() {
520 check_install_iptables_persistent
521
522 if ! sudo iptables -t nat -C PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST; then
523 sudo iptables -t nat -A PREROUTING -p tcp -m tcp -d $DEFAULT_IP --dport 17070 -j DNAT --to-destination $OSM_VCA_HOST
524 sudo netfilter-persistent save
525 fi
526 }
527
528 function docker_login() {
529 echo "Docker login"
530 sg docker -c "docker login -u ${DOCKER_REGISTRY_USER} -p ${DOCKER_REGISTRY_PASSWORD}"
531 }
532
533 function generate_docker_images() {
534 echo "Pulling and generating docker images"
535 [ -n "${DOCKER_REGISTRY_URL}" ] && docker_login
536
537 echo "Pulling docker images"
538
539 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q KAFKA ; then
540 sg docker -c "docker pull wurstmeister/zookeeper" || FATAL "cannot get zookeeper docker image"
541 sg docker -c "docker pull wurstmeister/kafka:${KAFKA_TAG}" || FATAL "cannot get kafka docker image"
542 fi
543
544 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q MONGO ; then
545 sg docker -c "docker pull mongo" || FATAL "cannot get mongo docker image"
546 fi
547
548 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS ; then
549 sg docker -c "docker pull prom/prometheus:${PROMETHEUS_TAG}" || FATAL "cannot get prometheus docker image"
550 fi
551
552 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q PROMETHEUS-CADVISOR ; then
553 sg docker -c "docker pull google/cadvisor:${PROMETHEUS_CADVISOR_TAG}" || FATAL "cannot get prometheus cadvisor docker image"
554 fi
555
556 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q GRAFANA ; then
557 sg docker -c "docker pull grafana/grafana:${GRAFANA_TAG}" || FATAL "cannot get grafana docker image"
558 fi
559
560 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q NBI || echo $TO_REBUILD | grep -q KEYSTONE-DB ; then
561 sg docker -c "docker pull mariadb:${KEYSTONEDB_TAG}" || FATAL "cannot get keystone-db docker image"
562 fi
563
564 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q RO ; then
565 sg docker -c "docker pull mysql:5" || FATAL "cannot get mysql docker image"
566 fi
567
568 if [ -n "$PULL_IMAGES" ]; then
569 echo "Pulling OSM docker images"
570 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA osmclient; do
571 module_lower=${module,,}
572 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
573 continue
574 fi
575 module_tag="${OSM_DOCKER_TAG}"
576 if [ -n "${MODULE_DOCKER_TAG}" ] && echo $TO_REBUILD | grep -q $module ; then
577 module_tag="${MODULE_DOCKER_TAG}"
578 fi
579 echo "Pulling ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag} docker image"
580 sg docker -c "docker pull ${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module_lower}:${module_tag}" || FATAL "cannot pull $module docker image"
581 done
582 else
583 _build_from=$COMMIT_ID
584 [ -z "$_build_from" ] && _build_from="latest"
585 echo "OSM Docker images generated from $_build_from"
586
587 for module in MON POL NBI KEYSTONE RO LCM NG-UI PLA; do
588 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q ${module} ; then
589 module_lower=${module,,}
590 if [ $module == "PLA" -a ! -n "$INSTALL_PLA" ]; then
591 continue
592 fi
593 git -C ${LWTEMPDIR} clone https://osm.etsi.org/gerrit/osm/$module
594 git -C ${LWTEMPDIR}/${module} checkout ${COMMIT_ID}
595 sg docker -c "docker build ${LWTEMPDIR}/${module} -f ${LWTEMPDIR}/${module}/docker/Dockerfile -t ${DOCKER_USER}/${module_lower} --no-cache" || FATAL "cannot build ${module} docker image"
596 fi
597 done
598 if [ -z "$TO_REBUILD" ] || echo $TO_REBUILD | grep -q osmclient; then
599 BUILD_ARGS+=(--build-arg REPOSITORY="$REPOSITORY")
600 BUILD_ARGS+=(--build-arg RELEASE="$RELEASE")
601 BUILD_ARGS+=(--build-arg REPOSITORY_KEY="$REPOSITORY_KEY")
602 BUILD_ARGS+=(--build-arg REPOSITORY_BASE="$REPOSITORY_BASE")
603 sg docker -c "docker build -t ${DOCKER_USER}/osmclient ${BUILD_ARGS[@]} -f $OSM_DEVOPS/docker/osmclient ."
604 fi
605 echo "Finished generation of docker images"
606 fi
607
608 echo "Finished pulling and generating docker images"
609 }
610
611 function cmp_overwrite() {
612 file1="$1"
613 file2="$2"
614 if ! $(cmp "${file1}" "${file2}" >/dev/null 2>&1); then
615 if [ -f "${file2}" ]; then
616 ask_user "The file ${file2} already exists. Overwrite (y/N)? " n && cp -b ${file1} ${file2}
617 else
618 cp -b ${file1} ${file2}
619 fi
620 fi
621 }
622
623 function generate_docker_compose_files() {
624 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/docker-compose.yaml $OSM_DOCKER_WORK_DIR/docker-compose.yaml
625 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/docker-compose-ngui.yaml $OSM_DOCKER_WORK_DIR/docker-compose-ui.yaml
626 if [ -n "$INSTALL_PLA" ]; then
627 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/osm_pla/docker-compose.yaml $OSM_DOCKER_WORK_DIR/osm_pla/docker-compose.yaml
628 fi
629 }
630
631 function generate_k8s_manifest_files() {
632 #Kubernetes resources
633 $WORKDIR_SUDO cp -bR ${OSM_DEVOPS}/installers/docker/osm_pods $OSM_DOCKER_WORK_DIR
634 $WORKDIR_SUDO rm -f $OSM_K8S_WORK_DIR/mongo.yaml
635 }
636
637 function generate_prometheus_grafana_files() {
638 [ -n "$KUBERNETES" ] && return
639 # Prometheus files
640 $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/prometheus
641 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/prometheus/prometheus.yml $OSM_DOCKER_WORK_DIR/prometheus/prometheus.yml
642
643 # Grafana files
644 $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/grafana
645 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/dashboards-osm.yml $OSM_DOCKER_WORK_DIR/grafana/dashboards-osm.yml
646 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/datasource-prometheus.yml $OSM_DOCKER_WORK_DIR/grafana/datasource-prometheus.yml
647 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/osm-sample-dashboard.json $OSM_DOCKER_WORK_DIR/grafana/osm-sample-dashboard.json
648 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/grafana/osm-system-dashboard.json $OSM_DOCKER_WORK_DIR/grafana/osm-system-dashboard.json
649
650 # Prometheus Exporters files
651 $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/prometheus_exporters
652 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/prometheus_exporters/node_exporter.service $OSM_DOCKER_WORK_DIR/prometheus_exporters/node_exporter.service
653 }
654
655 function generate_docker_env_files() {
656 echo "Doing a backup of existing env files"
657 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/keystone-db.env{,~}
658 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/keystone.env{,~}
659 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/lcm.env{,~}
660 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/mon.env{,~}
661 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/nbi.env{,~}
662 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/pol.env{,~}
663 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/ro-db.env{,~}
664 $WORKDIR_SUDO cp $OSM_DOCKER_WORK_DIR/ro.env{,~}
665
666 echo "Generating docker env files"
667 # LCM
668 if [ ! -f $OSM_DOCKER_WORK_DIR/lcm.env ]; then
669 echo "OSMLCM_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
670 fi
671
672 if ! grep -Fq "OSMLCM_VCA_HOST" $OSM_DOCKER_WORK_DIR/lcm.env; then
673 echo "OSMLCM_VCA_HOST=${OSM_VCA_HOST}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
674 else
675 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_HOST.*|OSMLCM_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/lcm.env
676 fi
677
678 if ! grep -Fq "OSMLCM_VCA_SECRET" $OSM_DOCKER_WORK_DIR/lcm.env; then
679 echo "OSMLCM_VCA_SECRET=${OSM_VCA_SECRET}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
680 else
681 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_SECRET.*|OSMLCM_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/lcm.env
682 fi
683
684 if ! grep -Fq "OSMLCM_VCA_PUBKEY" $OSM_DOCKER_WORK_DIR/lcm.env; then
685 echo "OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
686 else
687 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_PUBKEY.*|OSMLCM_VCA_PUBKEY=${OSM_VCA_PUBKEY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
688 fi
689
690 if ! grep -Fq "OSMLCM_VCA_CACERT" $OSM_DOCKER_WORK_DIR/lcm.env; then
691 echo "OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
692 else
693 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_CACERT.*|OSMLCM_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/lcm.env
694 fi
695
696 if [ -n "$OSM_VCA_APIPROXY" ]; then
697 if ! grep -Fq "OSMLCM_VCA_APIPROXY" $OSM_DOCKER_WORK_DIR/lcm.env; then
698 echo "OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
699 else
700 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_APIPROXY.*|OSMLCM_VCA_APIPROXY=${OSM_VCA_APIPROXY}|g" $OSM_DOCKER_WORK_DIR/lcm.env
701 fi
702 fi
703
704 if ! grep -Fq "OSMLCM_VCA_ENABLEOSUPGRADE" $OSM_DOCKER_WORK_DIR/lcm.env; then
705 echo "# OSMLCM_VCA_ENABLEOSUPGRADE=false" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
706 fi
707
708 if ! grep -Fq "OSMLCM_VCA_APTMIRROR" $OSM_DOCKER_WORK_DIR/lcm.env; then
709 echo "# OSMLCM_VCA_APTMIRROR=http://archive.ubuntu.com/ubuntu/" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
710 fi
711
712 if ! grep -Fq "OSMLCM_VCA_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
713 echo "OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
714 else
715 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_CLOUD.*|OSMLCM_VCA_CLOUD=${OSM_VCA_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
716 fi
717
718 if ! grep -Fq "OSMLCM_VCA_K8S_CLOUD" $OSM_DOCKER_WORK_DIR/lcm.env; then
719 echo "OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/lcm.env
720 else
721 $WORKDIR_SUDO sed -i "s|OSMLCM_VCA_K8S_CLOUD.*|OSMLCM_VCA_K8S_CLOUD=${OSM_VCA_K8S_CLOUDNAME}|g" $OSM_DOCKER_WORK_DIR/lcm.env
722 fi
723
724 # RO
725 MYSQL_ROOT_PASSWORD=$(generate_secret)
726 if [ ! -f $OSM_DOCKER_WORK_DIR/ro-db.env ]; then
727 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/ro-db.env
728 fi
729 if [ ! -f $OSM_DOCKER_WORK_DIR/ro.env ]; then
730 echo "RO_DB_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/ro.env
731 fi
732 if ! grep -Fq "OSMRO_DATABASE_COMMONKEY" $OSM_DOCKER_WORK_DIR/ro.env; then
733 echo "OSMRO_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/ro.env
734 fi
735
736 # Keystone
737 KEYSTONE_DB_PASSWORD=$(generate_secret)
738 SERVICE_PASSWORD=$(generate_secret)
739 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone-db.env ]; then
740 echo "MYSQL_ROOT_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/keystone-db.env
741 fi
742 if [ ! -f $OSM_DOCKER_WORK_DIR/keystone.env ]; then
743 echo "ROOT_DB_PASSWORD=${MYSQL_ROOT_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/keystone.env
744 echo "KEYSTONE_DB_PASSWORD=${KEYSTONE_DB_PASSWORD}" |$WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/keystone.env
745 echo "SERVICE_PASSWORD=${SERVICE_PASSWORD}" |$WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/keystone.env
746 fi
747
748 # NBI
749 if [ ! -f $OSM_DOCKER_WORK_DIR/nbi.env ]; then
750 echo "OSMNBI_AUTHENTICATION_SERVICE_PASSWORD=${SERVICE_PASSWORD}" |$WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/nbi.env
751 echo "OSMNBI_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/nbi.env
752 fi
753
754 # MON
755 if [ ! -f $OSM_DOCKER_WORK_DIR/mon.env ]; then
756 echo "OSMMON_KEYSTONE_SERVICE_PASSWORD=${SERVICE_PASSWORD}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
757 echo "OSMMON_DATABASE_COMMONKEY=${OSM_DATABASE_COMMONKEY}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
758 echo "OSMMON_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/mon" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
759 fi
760
761 if ! grep -Fq "OS_NOTIFIER_URI" $OSM_DOCKER_WORK_DIR/mon.env; then
762 echo "OS_NOTIFIER_URI=http://${DEFAULT_IP}:8662" |$WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
763 else
764 $WORKDIR_SUDO sed -i "s|OS_NOTIFIER_URI.*|OS_NOTIFIER_URI=http://$DEFAULT_IP:8662|g" $OSM_DOCKER_WORK_DIR/mon.env
765 fi
766
767 if ! grep -Fq "OSMMON_VCA_HOST" $OSM_DOCKER_WORK_DIR/mon.env; then
768 echo "OSMMON_VCA_HOST=${OSM_VCA_HOST}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
769 else
770 $WORKDIR_SUDO sed -i "s|OSMMON_VCA_HOST.*|OSMMON_VCA_HOST=$OSM_VCA_HOST|g" $OSM_DOCKER_WORK_DIR/mon.env
771 fi
772
773 if ! grep -Fq "OSMMON_VCA_SECRET" $OSM_DOCKER_WORK_DIR/mon.env; then
774 echo "OSMMON_VCA_SECRET=${OSM_VCA_SECRET}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
775 else
776 $WORKDIR_SUDO sed -i "s|OSMMON_VCA_SECRET.*|OSMMON_VCA_SECRET=$OSM_VCA_SECRET|g" $OSM_DOCKER_WORK_DIR/mon.env
777 fi
778
779 if ! grep -Fq "OSMMON_VCA_CACERT" $OSM_DOCKER_WORK_DIR/mon.env; then
780 echo "OSMMON_VCA_CACERT=${OSM_VCA_CACERT}" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/mon.env
781 else
782 $WORKDIR_SUDO sed -i "s|OSMMON_VCA_CACERT.*|OSMMON_VCA_CACERT=${OSM_VCA_CACERT}|g" $OSM_DOCKER_WORK_DIR/mon.env
783 fi
784
785
786 # POL
787 if [ ! -f $OSM_DOCKER_WORK_DIR/pol.env ]; then
788 echo "OSMPOL_SQL_DATABASE_URI=mysql://root:${MYSQL_ROOT_PASSWORD}@mysql:3306/pol" | $WORKDIR_SUDO tee -a $OSM_DOCKER_WORK_DIR/pol.env
789 fi
790
791 echo "Finished generation of docker env files"
792 }
793
794 function generate_osmclient_script () {
795 echo "docker run -ti --network net${OSM_STACK_NAME} ${DOCKER_REGISTRY_URL}${DOCKER_USER}/osmclient:${OSM_DOCKER_TAG}" | $WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/osm
796 $WORKDIR_SUDO chmod +x "$OSM_DOCKER_WORK_DIR/osm"
797 echo "osmclient sidecar container can be found at: $OSM_DOCKER_WORK_DIR/osm"
798 }
799
800 #installs kubernetes packages
801 function install_kube() {
802 sudo apt-get update && sudo apt-get install -y apt-transport-https
803 curl -fsSL https://packages.cloud.google.com/apt/doc/apt-key.gpg | sudo apt-key add -
804 sudo add-apt-repository "deb https://apt.kubernetes.io/ kubernetes-xenial main"
805 sudo apt-get update
806 echo "Installing Kubernetes Packages ..."
807 sudo apt-get install -y kubelet=1.15.0-00 kubeadm=1.15.0-00 kubectl=1.15.0-00
808 sudo apt-mark hold kubelet kubeadm kubectl
809 }
810
811 #initializes kubernetes control plane
812 function init_kubeadm() {
813 sudo swapoff -a
814 sudo sed -i.bak '/.*none.*swap/s/^\(.*\)$/#\1/g' /etc/fstab
815 sudo kubeadm init --config $1
816 sleep 5
817 }
818
819 function kube_config_dir() {
820 [ ! -d $K8S_MANIFEST_DIR ] && FATAL "Cannot Install Kubernetes"
821 mkdir -p $HOME/.kube
822 sudo cp /etc/kubernetes/admin.conf $HOME/.kube/config
823 sudo chown $(id -u):$(id -g) $HOME/.kube/config
824 }
825
826 function install_k8s_storageclass() {
827 OPENEBS_DIR="$(mktemp -d -q --tmpdir "openebs.XXXXXX")"
828 trap 'rm -rf "${OPENEBS_DIR}"' EXIT
829 wget -q https://openebs.github.io/charts/openebs-operator-1.6.0.yaml -P $OPENEBS_DIR
830 kubectl apply -f $OPENEBS_DIR
831 local storageclass_timeout=400
832 local counter=0
833 local storageclass_ready=""
834 echo "Waiting for storageclass"
835 while (( counter < storageclass_timeout ))
836 do
837 kubectl get storageclass openebs-hostpath &> /dev/null
838
839 if [ $? -eq 0 ] ; then
840 echo "Storageclass available"
841 storageclass_ready="y"
842 break
843 else
844 counter=$((counter + 15))
845 sleep 15
846 fi
847 done
848 [ -n "$storageclass_ready" ] || FATAL "Storageclass not ready after $storageclass_timeout seconds. Cannot install openebs"
849 kubectl patch storageclass openebs-hostpath -p '{"metadata": {"annotations":{"storageclass.kubernetes.io/is-default-class":"true"}}}'
850 }
851
852 function install_k8s_metallb() {
853 METALLB_IP_RANGE=$DEFAULT_IP-$DEFAULT_IP
854 cat ${OSM_DEVOPS}/installers/k8s/metallb/metallb.yaml | kubectl apply -f -
855 echo "apiVersion: v1
856 kind: ConfigMap
857 metadata:
858 namespace: metallb-system
859 name: config
860 data:
861 config: |
862 address-pools:
863 - name: default
864 protocol: layer2
865 addresses:
866 - $METALLB_IP_RANGE" | kubectl apply -f -
867 }
868 #deploys flannel as daemonsets
869 function deploy_cni_provider() {
870 CNI_DIR="$(mktemp -d -q --tmpdir "flannel.XXXXXX")"
871 trap 'rm -rf "${CNI_DIR}"' EXIT
872 wget -q https://raw.githubusercontent.com/coreos/flannel/master/Documentation/kube-flannel.yml -P $CNI_DIR
873 kubectl apply -f $CNI_DIR
874 [ $? -ne 0 ] && FATAL "Cannot Install Flannel"
875 }
876
877 #creates secrets from env files which will be used by containers
878 function kube_secrets(){
879 kubectl create ns $OSM_STACK_NAME
880 kubectl create secret generic lcm-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/lcm.env
881 kubectl create secret generic mon-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/mon.env
882 kubectl create secret generic nbi-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/nbi.env
883 kubectl create secret generic ro-db-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro-db.env
884 kubectl create secret generic ro-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/ro.env
885 kubectl create secret generic keystone-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/keystone.env
886 kubectl create secret generic pol-secret -n $OSM_STACK_NAME --from-env-file=$OSM_DOCKER_WORK_DIR/pol.env
887 }
888
889 #taints K8s master node
890 function taint_master_node() {
891 K8S_MASTER=$(kubectl get nodes | awk '$3~/master/'| awk '{print $1}')
892 kubectl taint node $K8S_MASTER node-role.kubernetes.io/master:NoSchedule-
893 sleep 5
894 }
895
896 #deploys osm pods and services
897 function deploy_osm_services() {
898 kubectl apply -n $OSM_STACK_NAME -f $OSM_K8S_WORK_DIR
899 }
900
901 #deploy charmed services
902 function deploy_charmed_services() {
903 juju add-model $OSM_STACK_NAME $OSM_VCA_K8S_CLOUDNAME
904 juju deploy ch:mongodb-k8s -m $OSM_STACK_NAME
905 }
906
907 function deploy_osm_pla_service() {
908 # corresponding to namespace_vol
909 $WORKDIR_SUDO sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_DOCKER_WORK_DIR/osm_pla/pla.yaml
910 # corresponding to deploy_osm_services
911 kubectl apply -n $OSM_STACK_NAME -f $OSM_DOCKER_WORK_DIR/osm_pla
912 }
913
914 #Install helm and tiller
915 function install_helm() {
916 helm > /dev/null 2>&1
917 if [ $? != 0 ] ; then
918 # Helm is not installed. Install helm
919 echo "Helm is not installed, installing ..."
920 curl https://get.helm.sh/helm-v2.15.2-linux-amd64.tar.gz --output helm-v2.15.2.tar.gz
921 tar -zxvf helm-v2.15.2.tar.gz
922 sudo mv linux-amd64/helm /usr/local/bin/helm
923 rm -r linux-amd64
924 rm helm-v2.15.2.tar.gz
925 fi
926
927 # Checking if tiller has being configured
928 kubectl --namespace kube-system get serviceaccount tiller > /dev/null 2>&1
929 if [ $? == 1 ] ; then
930 # tiller account for kubernetes
931 kubectl --namespace kube-system create serviceaccount tiller
932 kubectl create clusterrolebinding tiller-cluster-rule --clusterrole=cluster-admin --serviceaccount=kube-system:tiller
933 # HELM initialization
934 helm init --stable-repo-url https://charts.helm.sh/stable --service-account tiller
935
936 # Wait for Tiller to be up and running. If timeout expires, continue installing
937 tiller_timeout=120;
938 counter=0;
939 tiller_status=""
940 while (( counter < tiller_timeout ))
941 do
942 tiller_status=`kubectl -n kube-system get deployment.apps/tiller-deploy --no-headers | awk '{print $2'}`
943 ( [ ! -z "$tiller_status" ] && [ $tiller_status == "1/1" ] ) && echo "Tiller ready" && break
944 counter=$((counter + 5))
945 sleep 5
946 done
947 [ "$tiller_status" != "1/1" ] && echo "Tiller is NOT READY YET. Installation will continue"
948 fi
949 }
950
951 function parse_yaml() {
952 TAG=$1
953 shift
954 services=$@
955 for module in $services; do
956 if [ "$module" == "pla" ]; then
957 if [ -n "$INSTALL_PLA" ]; then
958 echo "Updating K8s manifest file from opensourcemano\/${module}:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/${module}:${TAG}"
959 $WORKDIR_SUDO sed -i "s#opensourcemano/pla:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/pla:${TAG}#g" ${OSM_DOCKER_WORK_DIR}/osm_pla/pla.yaml
960 fi
961 else
962 echo "Updating K8s manifest file from opensourcemano\/${module}:.* to ${DOCKER_REGISTRY_URL}${DOCKER_USER}\/${module}:${TAG}"
963 $WORKDIR_SUDO sed -i "s#opensourcemano/${module}:.*#${DOCKER_REGISTRY_URL}${DOCKER_USER}/${module}:${TAG}#g" ${OSM_K8S_WORK_DIR}/${module}.yaml
964 fi
965 done
966 }
967
968 function update_manifest_files() {
969 osm_services="nbi lcm ro pol mon ng-ui keystone pla"
970 list_of_services=""
971 for module in $osm_services; do
972 module_upper="${module^^}"
973 if ! echo $TO_REBUILD | grep -q $module_upper ; then
974 list_of_services="$list_of_services $module"
975 fi
976 done
977 if [ ! "$OSM_DOCKER_TAG" == "10" ]; then
978 parse_yaml $OSM_DOCKER_TAG $list_of_services
979 fi
980 if [ -n "$MODULE_DOCKER_TAG" ]; then
981 parse_yaml $MODULE_DOCKER_TAG $list_of_services_to_rebuild
982 fi
983 }
984
985 function namespace_vol() {
986 osm_services="nbi lcm ro pol mon kafka mysql prometheus"
987 for osm in $osm_services; do
988 $WORKDIR_SUDO sed -i "s#path: /var/lib/osm#path: $OSM_NAMESPACE_VOL#g" $OSM_K8S_WORK_DIR/$osm.yaml
989 done
990 }
991
992 function init_docker_swarm() {
993 if [ "${DEFAULT_MTU}" != "1500" ]; then
994 DOCKER_NETS=`sg docker -c "docker network list" | awk '{print $2}' | egrep -v "^ID$" | paste -d " " -s`
995 DOCKER_GW_NET=`sg docker -c "docker network inspect ${DOCKER_NETS}" | grep Subnet | awk -F\" '{print $4}' | egrep "^172" | sort -u | tail -1 | awk -F\. '{if ($2 != 255) print $1"."$2+1"."$3"."$4; else print "-1";}'`
996 sg docker -c "docker network create --subnet ${DOCKER_GW_NET} --opt com.docker.network.bridge.name=docker_gwbridge --opt com.docker.network.bridge.enable_icc=false --opt com.docker.network.bridge.enable_ip_masquerade=true --opt com.docker.network.driver.mtu=${DEFAULT_MTU} docker_gwbridge"
997 fi
998 sg docker -c "docker swarm init --advertise-addr ${DEFAULT_IP}"
999 return 0
1000 }
1001
1002 function create_docker_network() {
1003 echo "creating network"
1004 sg docker -c "docker network create --driver=overlay --attachable --opt com.docker.network.driver.mtu=${DEFAULT_MTU} net${OSM_STACK_NAME}"
1005 echo "creating network DONE"
1006 }
1007
1008 function deploy_lightweight() {
1009
1010 echo "Deploying lightweight build"
1011 OSM_NBI_PORT=9999
1012 OSM_RO_PORT=9090
1013 OSM_KEYSTONE_PORT=5000
1014 OSM_UI_PORT=80
1015 OSM_MON_PORT=8662
1016 OSM_PROM_PORT=9090
1017 OSM_PROM_CADVISOR_PORT=8080
1018 OSM_PROM_HOSTPORT=9091
1019 OSM_GRAFANA_PORT=3000
1020 [ -n "$INSTALL_ELK" ] && OSM_ELK_PORT=5601
1021 #[ -n "$INSTALL_PERFMON" ] && OSM_PM_PORT=3000
1022
1023 if [ -n "$NO_HOST_PORTS" ]; then
1024 OSM_PORTS+=(OSM_NBI_PORTS=$OSM_NBI_PORT)
1025 OSM_PORTS+=(OSM_RO_PORTS=$OSM_RO_PORT)
1026 OSM_PORTS+=(OSM_KEYSTONE_PORTS=$OSM_KEYSTONE_PORT)
1027 OSM_PORTS+=(OSM_UI_PORTS=$OSM_UI_PORT)
1028 OSM_PORTS+=(OSM_MON_PORTS=$OSM_MON_PORT)
1029 OSM_PORTS+=(OSM_PROM_PORTS=$OSM_PROM_PORT)
1030 OSM_PORTS+=(OSM_PROM_CADVISOR_PORTS=$OSM_PROM_CADVISOR_PORT)
1031 OSM_PORTS+=(OSM_GRAFANA_PORTS=$OSM_GRAFANA_PORT)
1032 #[ -n "$INSTALL_PERFMON" ] && OSM_PORTS+=(OSM_PM_PORTS=$OSM_PM_PORT)
1033 [ -n "$INSTALL_ELK" ] && OSM_PORTS+=(OSM_ELK_PORTS=$OSM_ELK_PORT)
1034 else
1035 OSM_PORTS+=(OSM_NBI_PORTS=$OSM_NBI_PORT:$OSM_NBI_PORT)
1036 OSM_PORTS+=(OSM_RO_PORTS=$OSM_RO_PORT:$OSM_RO_PORT)
1037 OSM_PORTS+=(OSM_KEYSTONE_PORTS=$OSM_KEYSTONE_PORT:$OSM_KEYSTONE_PORT)
1038 OSM_PORTS+=(OSM_UI_PORTS=$OSM_UI_PORT:$OSM_UI_PORT)
1039 OSM_PORTS+=(OSM_MON_PORTS=$OSM_MON_PORT:$OSM_MON_PORT)
1040 OSM_PORTS+=(OSM_PROM_PORTS=$OSM_PROM_HOSTPORT:$OSM_PROM_PORT)
1041 OSM_PORTS+=(OSM_PROM_CADVISOR_PORTS=$OSM_PROM_CADVISOR_PORT:$OSM_PROM_CADVISOR_PORT)
1042 OSM_PORTS+=(OSM_GRAFANA_PORTS=$OSM_GRAFANA_PORT:$OSM_GRAFANA_PORT)
1043 #[ -n "$INSTALL_PERFMON" ] && OSM_PORTS+=(OSM_PM_PORTS=$OSM_PM_PORT:$OSM_PM_PORT)
1044 [ -n "$INSTALL_ELK" ] && OSM_PORTS+=(OSM_ELK_PORTS=$OSM_ELK_PORT:$OSM_ELK_PORT)
1045 fi
1046 echo "export ${OSM_PORTS[@]}" | $WORKDIR_SUDO tee $OSM_DOCKER_WORK_DIR/osm_ports.sh
1047 echo "export OSM_NETWORK=net${OSM_STACK_NAME}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1048 echo "export TAG=${OSM_DOCKER_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1049 echo "export DOCKER_USER=${DOCKER_USER}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1050 echo "export KAFKA_TAG=${KAFKA_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1051 echo "export PROMETHEUS_TAG=${PROMETHEUS_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1052 echo "export KEYSTONEDB_TAG=${KEYSTONEDB_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1053 echo "export PROMETHEUS_CADVISOR_TAG=${PROMETHEUS_CADVISOR_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1054 echo "export GRAFANA_TAG=${GRAFANA_TAG}" | $WORKDIR_SUDO tee --append $OSM_DOCKER_WORK_DIR/osm_ports.sh
1055
1056 pushd $OSM_DOCKER_WORK_DIR
1057 if [ -n "$INSTALL_PLA" ]; then
1058 track deploy_osm_pla
1059 sg docker -c ". ./osm_ports.sh; docker stack deploy -c $OSM_DOCKER_WORK_DIR/docker-compose.yaml -c $OSM_DOCKER_WORK_DIR/docker-compose-ui.yaml -c $OSM_DOCKER_WORK_DIR/osm_pla/docker-compose.yaml $OSM_STACK_NAME"
1060 else
1061 sg docker -c ". ./osm_ports.sh; docker stack deploy -c $OSM_DOCKER_WORK_DIR/docker-compose.yaml -c $OSM_DOCKER_WORK_DIR/docker-compose-ui.yaml $OSM_STACK_NAME"
1062 fi
1063 popd
1064
1065 echo "Finished deployment of lightweight build"
1066 }
1067
1068 function deploy_elk() {
1069 echo "Pulling docker images for ELK"
1070 sg docker -c "docker pull docker.elastic.co/elasticsearch/elasticsearch-oss:${ELASTIC_VERSION}" || FATAL "cannot get elasticsearch docker image"
1071 sg docker -c "docker pull docker.elastic.co/beats/metricbeat:${ELASTIC_VERSION}" || FATAL "cannot get metricbeat docker image"
1072 sg docker -c "docker pull docker.elastic.co/beats/filebeat:${ELASTIC_VERSION}" || FATAL "cannot get filebeat docker image"
1073 sg docker -c "docker pull docker.elastic.co/kibana/kibana-oss:${ELASTIC_VERSION}" || FATAL "cannot get kibana docker image"
1074 sg docker -c "docker pull bobrik/curator:${ELASTIC_CURATOR_VERSION}" || FATAL "cannot get curator docker image"
1075 echo "Finished pulling elk docker images"
1076 $WORKDIR_SUDO mkdir -p "$OSM_DOCKER_WORK_DIR/osm_elk"
1077 $WORKDIR_SUDO cp -b ${OSM_DEVOPS}/installers/docker/osm_elk/* $OSM_DOCKER_WORK_DIR/osm_elk
1078 remove_stack osm_elk
1079 echo "Deploying ELK stack"
1080 sg docker -c "OSM_NETWORK=net${OSM_STACK_NAME} docker stack deploy -c $OSM_DOCKER_WORK_DIR/osm_elk/docker-compose.yml osm_elk"
1081 echo "Waiting for ELK stack to be up and running"
1082 time=0
1083 step=5
1084 timelength=40
1085 elk_is_up=1
1086 while [ $time -le $timelength ]; do
1087 if [[ $(curl -f -XGET http://127.0.0.1:5601/status -I 2>/dev/null | grep "HTTP/1.1 200 OK" | wc -l ) -eq 1 ]]; then
1088 elk_is_up=0
1089 break
1090 fi
1091 sleep $step
1092 time=$((time+step))
1093 done
1094 if [ $elk_is_up -eq 0 ]; then
1095 echo "ELK is up and running. Trying to create index pattern..."
1096 #Create index pattern
1097 curl -f -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
1098 "http://127.0.0.1:5601/api/saved_objects/index-pattern/filebeat-*" \
1099 -d"{\"attributes\":{\"title\":\"filebeat-*\",\"timeFieldName\":\"@timestamp\"}}" 2>/dev/null
1100 #Make it the default index
1101 curl -f -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
1102 "http://127.0.0.1:5601/api/kibana/settings/defaultIndex" \
1103 -d"{\"value\":\"filebeat-*\"}" 2>/dev/null
1104 else
1105 echo "Cannot connect to Kibana to create index pattern."
1106 echo "Once Kibana is running, you can use the following instructions to create index pattern:"
1107 echo 'curl -f -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
1108 "http://127.0.0.1:5601/api/saved_objects/index-pattern/filebeat-*" \
1109 -d"{\"attributes\":{\"title\":\"filebeat-*\",\"timeFieldName\":\"@timestamp\"}}"'
1110 echo 'curl -XPOST -H "Content-Type: application/json" -H "kbn-xsrf: anything" \
1111 "http://127.0.0.1:5601/api/kibana/settings/defaultIndex" \
1112 -d"{\"value\":\"filebeat-*\"}"'
1113 fi
1114 echo "Finished deployment of ELK stack"
1115 return 0
1116 }
1117
1118 function add_local_k8scluster() {
1119 /usr/bin/osm --all-projects vim-create \
1120 --name _system-osm-vim \
1121 --account_type dummy \
1122 --auth_url http://dummy \
1123 --user osm --password osm --tenant osm \
1124 --description "dummy" \
1125 --config '{management_network_name: mgmt}'
1126 /usr/bin/osm --all-projects k8scluster-add \
1127 --creds ${HOME}/.kube/config \
1128 --vim _system-osm-vim \
1129 --k8s-nets '{"net1": null}' \
1130 --version '1.15' \
1131 --description "OSM Internal Cluster" \
1132 _system-osm-k8s
1133 }
1134
1135 function install_lightweight() {
1136 track checkingroot
1137 [ "$USER" == "root" ] && FATAL "You are running the installer as root. The installer is prepared to be executed as a normal user with sudo privileges."
1138 track noroot
1139
1140 if [ -n "$KUBERNETES" ]; then
1141 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will do the following
1142 1. Install and configure LXD
1143 2. Install juju
1144 3. Install docker CE
1145 4. Disable swap space
1146 5. Install and initialize Kubernetes
1147 as pre-requirements.
1148 Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
1149
1150 else
1151 [ -z "$ASSUME_YES" ] && ! ask_user "The installation will configure LXD, install juju, install docker CE and init a docker swarm, as pre-requirements. Do you want to proceed (Y/n)? " y && echo "Cancelled!" && exit 1
1152 fi
1153 track proceed
1154
1155 echo "Installing lightweight build of OSM"
1156 LWTEMPDIR="$(mktemp -d -q --tmpdir "installosmlight.XXXXXX")"
1157 trap 'rm -rf "${LWTEMPDIR}"' EXIT
1158 DEFAULT_IF=$(ip route list|awk '$1=="default" {print $5; exit}')
1159 [ -z "$DEFAULT_IF" ] && DEFAULT_IF=$(route -n |awk '$1~/^0.0.0.0/ {print $8; exit}')
1160 [ -z "$DEFAULT_IF" ] && FATAL "Not possible to determine the interface with the default route 0.0.0.0"
1161 DEFAULT_IP=`ip -o -4 a s ${DEFAULT_IF} |awk '{split($4,a,"/"); print a[1]}'`
1162 [ -z "$DEFAULT_IP" ] && FATAL "Not possible to determine the IP address of the interface with the default route"
1163 DEFAULT_MTU=$(ip addr show ${DEFAULT_IF} | perl -ne 'if (/mtu\s(\d+)/) {print $1;}')
1164
1165 # if no host is passed in, we need to install lxd/juju, unless explicilty asked not to
1166 if [ -z "$OSM_VCA_HOST" ] && [ -z "$INSTALL_NOLXD" ] && [ -z "$LXD_CLOUD_FILE" ]; then
1167 need_packages_lw="snapd"
1168 echo -e "Checking required packages: $need_packages_lw"
1169 dpkg -l $need_packages_lw &>/dev/null \
1170 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
1171 || sudo apt-get update \
1172 || FATAL "failed to run apt-get update"
1173 dpkg -l $need_packages_lw &>/dev/null \
1174 || ! echo -e "Installing $need_packages_lw requires root privileges." \
1175 || sudo apt-get install -y $need_packages_lw \
1176 || FATAL "failed to install $need_packages_lw"
1177 install_lxd
1178 fi
1179
1180 track prereqok
1181
1182 [ -n "$INSTALL_NODOCKER" ] || (install_docker_ce && track docker_ce)
1183
1184 echo "Creating folders for installation"
1185 [ ! -d "$OSM_DOCKER_WORK_DIR" ] && $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR
1186 [ ! -d "$OSM_DOCKER_WORK_DIR/osm_pla" -a -n "$INSTALL_PLA" ] && $WORKDIR_SUDO mkdir -p $OSM_DOCKER_WORK_DIR/osm_pla
1187 [ -n "$KUBERNETES" ] && $WORKDIR_SUDO cp -b $OSM_DEVOPS/installers/docker/cluster-config.yaml $OSM_DOCKER_WORK_DIR/cluster-config.yaml
1188
1189 #Installs Kubernetes
1190 if [ -n "$KUBERNETES" ]; then
1191 install_kube
1192 track install_k8s
1193 init_kubeadm $OSM_DOCKER_WORK_DIR/cluster-config.yaml
1194 kube_config_dir
1195 track init_k8s
1196 if [ -n "$INSTALL_K8S_MONITOR" ]; then
1197 # uninstall OSM MONITORING
1198 uninstall_k8s_monitoring
1199 track uninstall_k8s_monitoring
1200 fi
1201 #remove old namespace
1202 remove_k8s_namespace $OSM_STACK_NAME
1203 deploy_cni_provider
1204 taint_master_node
1205 install_k8s_storageclass
1206 track k8s_storageclass
1207 install_k8s_metallb
1208 track k8s_metallb
1209 else
1210 #install_docker_compose
1211 [ -n "$INSTALL_NODOCKER" ] || init_docker_swarm
1212 track docker_swarm
1213 fi
1214
1215 [ -z "$INSTALL_NOJUJU" ] && install_juju
1216 track juju_install
1217
1218 if [ -z "$OSM_VCA_HOST" ]; then
1219 if [ -z "$CONTROLLER_NAME" ]; then
1220
1221 if [ -n "$KUBERNETES" ]; then
1222 juju_createcontroller_k8s
1223 juju_addlxd_cloud
1224 else
1225 if [ -n "$LXD_CLOUD_FILE" ]; then
1226 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
1227 OSM_VCA_CLOUDNAME="lxd-cloud"
1228 juju add-cloud $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud $OSM_VCA_CLOUDNAME --client -f $LXD_CLOUD_FILE
1229 juju add-credential $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential $OSM_VCA_CLOUDNAME lxd-cloud-creds -f $LXD_CRED_FILE
1230 fi
1231 juju_createcontroller
1232 juju_createproxy
1233 fi
1234 else
1235 OSM_VCA_CLOUDNAME="lxd-cloud"
1236 if [ -n "$LXD_CLOUD_FILE" ]; then
1237 [ -z "$LXD_CRED_FILE" ] && FATAL "The installer needs the LXD credential yaml if the LXD is external"
1238 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME $LXD_CLOUD_FILE --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f $LXD_CLOUD_FILE
1239 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f $LXD_CRED_FILE || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f $LXD_CRED_FILE
1240 else
1241 mkdir -p ~/.osm
1242 cat << EOF > ~/.osm/lxd-cloud.yaml
1243 clouds:
1244 lxd-cloud:
1245 type: lxd
1246 auth-types: [certificate]
1247 endpoint: "https://$DEFAULT_IP:8443"
1248 config:
1249 ssl-hostname-verification: false
1250 EOF
1251 openssl req -nodes -new -x509 -keyout ~/.osm/client.key -out ~/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
1252 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
1253 local client_cert=`cat ~/.osm/client.crt | sed 's/^/ /'`
1254 local client_key=`cat ~/.osm/client.key | sed 's/^/ /'`
1255 cat << EOF > ~/.osm/lxd-credentials.yaml
1256 credentials:
1257 lxd-cloud:
1258 lxd-cloud:
1259 auth-type: certificate
1260 server-cert: |
1261 $server_cert
1262 client-cert: |
1263 $client_cert
1264 client-key: |
1265 $client_key
1266 EOF
1267 lxc config trust add local: ~/.osm/client.crt
1268 juju add-cloud -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME ~/.osm/lxd-cloud.yaml --force || juju update-cloud lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-cloud.yaml
1269 juju add-credential -c $CONTROLLER_NAME $OSM_VCA_CLOUDNAME -f ~/.osm/lxd-credentials.yaml || juju update-credential lxd-cloud -c $CONTROLLER_NAME -f ~/.osm/lxd-credentials.yaml
1270 fi
1271 fi
1272 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`sg lxd -c "juju show-controller $OSM_STACK_NAME"|grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
1273 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_HOST=`juju show-controller $CONTROLLER_NAME |grep api-endpoints|awk -F\' '{print $2}'|awk -F\: '{print $1}'`
1274 [ -z "$OSM_VCA_HOST" ] && FATAL "Cannot obtain juju controller IP address"
1275 fi
1276 track juju_controller
1277
1278 if [ -z "$OSM_VCA_SECRET" ]; then
1279 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $OSM_STACK_NAME)
1280 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_SECRET=$(parse_juju_password $CONTROLLER_NAME)
1281 [ -z "$OSM_VCA_SECRET" ] && FATAL "Cannot obtain juju secret"
1282 fi
1283 if [ -z "$OSM_VCA_PUBKEY" ]; then
1284 OSM_VCA_PUBKEY=$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)
1285 [ -z "$OSM_VCA_PUBKEY" ] && FATAL "Cannot obtain juju public key"
1286 fi
1287 if [ -z "$OSM_VCA_CACERT" ]; then
1288 [ -z "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $OSM_STACK_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
1289 [ -n "$CONTROLLER_NAME" ] && OSM_VCA_CACERT=$(juju controllers --format json | jq -r --arg controller $CONTROLLER_NAME '.controllers[$controller]["ca-cert"]' | base64 | tr -d \\n)
1290 [ -z "$OSM_VCA_CACERT" ] && FATAL "Cannot obtain juju CA certificate"
1291 fi
1292
1293 # Set OSM_VCA_APIPROXY only when it is not a k8s installation
1294 if [ -z "$KUBERNETES" ]; then
1295 if [ -z "$OSM_VCA_APIPROXY" ]; then
1296 OSM_VCA_APIPROXY=$DEFAULT_IP
1297 [ -z "$OSM_VCA_APIPROXY" ] && FATAL "Cannot obtain juju api proxy"
1298 fi
1299 juju_createproxy
1300 fi
1301 track juju
1302
1303 if [ -z "$OSM_DATABASE_COMMONKEY" ]; then
1304 OSM_DATABASE_COMMONKEY=$(generate_secret)
1305 [ -z "OSM_DATABASE_COMMONKEY" ] && FATAL "Cannot generate common db secret"
1306 fi
1307
1308 # Deploy OSM services
1309 [ -z "$DOCKER_NOBUILD" ] && generate_docker_images
1310 track docker_build
1311
1312 if [ -n "$KUBERNETES" ]; then
1313 generate_k8s_manifest_files
1314 else
1315 generate_docker_compose_files
1316 fi
1317 track manifest_files
1318 generate_prometheus_grafana_files
1319 generate_docker_env_files
1320 track env_files
1321
1322 if [ -n "$KUBERNETES" ]; then
1323 deploy_charmed_services
1324 kube_secrets
1325 update_manifest_files
1326 namespace_vol
1327 deploy_osm_services
1328 if [ -n "$INSTALL_PLA"]; then
1329 # optional PLA install
1330 deploy_osm_pla_service
1331 track deploy_osm_pla
1332 fi
1333 track deploy_osm_services_k8s
1334 install_helm
1335 track install_helm
1336 if [ -n "$INSTALL_K8S_MONITOR" ]; then
1337 # install OSM MONITORING
1338 install_k8s_monitoring
1339 track install_k8s_monitoring
1340 fi
1341 else
1342 # remove old stack
1343 remove_stack $OSM_STACK_NAME
1344 create_docker_network
1345 deploy_lightweight
1346 generate_osmclient_script
1347 track docker_deploy
1348 install_prometheus_nodeexporter
1349 track nodeexporter
1350 [ -n "$INSTALL_VIMEMU" ] && install_vimemu && track vimemu
1351 [ -n "$INSTALL_ELK" ] && deploy_elk && track elk
1352 fi
1353
1354 [ -z "$INSTALL_NOHOSTCLIENT" ] && install_osmclient
1355 track osmclient
1356
1357 echo -e "Checking OSM health state..."
1358 if [ -n "$KUBERNETES" ]; then
1359 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_STACK_NAME} -k || \
1360 echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
1361 echo -e "Check OSM status with: kubectl -n ${OSM_STACK_NAME} get all" && \
1362 track osm_unhealthy
1363 else
1364 $OSM_DEVOPS/installers/osm_health.sh -s ${OSM_STACK_NAME} || \
1365 echo -e "OSM is not healthy, but will probably converge to a healthy state soon." && \
1366 echo -e "Check OSM status with: docker service ls; docker stack ps ${OSM_STACK_NAME}" && \
1367 track osm_unhealthy
1368 fi
1369 track after_healthcheck
1370
1371 [ -n "$KUBERNETES" ] && add_local_k8scluster
1372 track add_local_k8scluster
1373
1374 wget -q -O- https://osm-download.etsi.org/ftp/osm-10.0-ten/README2.txt &> /dev/null
1375 track end
1376 return 0
1377 }
1378
1379 function install_to_openstack() {
1380
1381 if [ -z "$2" ]; then
1382 FATAL "OpenStack installer requires a valid external network name"
1383 fi
1384
1385 # Install Pip for Python3
1386 $WORKDIR_SUDO apt install -y python3-pip python3-venv
1387 $WORKDIR_SUDO -H LC_ALL=C python3 -m pip install -U pip
1388
1389 # Create a venv to avoid conflicts with the host installation
1390 python3 -m venv $OPENSTACK_PYTHON_VENV
1391
1392 source $OPENSTACK_PYTHON_VENV/bin/activate
1393
1394 # Install Ansible, OpenStack client and SDK, latest openstack version supported is Train
1395 python -m pip install -U wheel
1396 python -m pip install -U "python-openstackclient<=4.0.2" "openstacksdk>=0.12.0,<=0.36.2" "ansible>=2.10,<2.11"
1397
1398 # Install the Openstack cloud module (ansible>=2.10)
1399 ansible-galaxy collection install openstack.cloud
1400
1401 export ANSIBLE_CONFIG="$OSM_DEVOPS/installers/openstack/ansible.cfg"
1402
1403 OSM_INSTALLER_ARGS="${REPO_ARGS[@]}"
1404
1405 ANSIBLE_VARS="external_network_name=$2 setup_volume=$3 server_name=$OPENSTACK_VM_NAME"
1406
1407 if [ -n "$OPENSTACK_SSH_KEY_FILE" ]; then
1408 ANSIBLE_VARS+=" key_file=$OPENSTACK_SSH_KEY_FILE"
1409 fi
1410
1411 if [ -n "$OPENSTACK_USERDATA_FILE" ]; then
1412 ANSIBLE_VARS+=" userdata_file=$OPENSTACK_USERDATA_FILE"
1413 fi
1414
1415 # Execute the Ansible playbook based on openrc or clouds.yaml
1416 if [ -e "$1" ]; then
1417 . $1
1418 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
1419 $OSM_DEVOPS/installers/openstack/site.yml
1420 else
1421 ansible-playbook -e installer_args="\"$OSM_INSTALLER_ARGS\"" -e "$ANSIBLE_VARS" \
1422 -e cloud_name=$1 $OSM_DEVOPS/installers/openstack/site.yml
1423 fi
1424
1425 # Exit from venv
1426 deactivate
1427
1428 return 0
1429 }
1430
1431 function install_vimemu() {
1432 echo "\nInstalling vim-emu"
1433 EMUTEMPDIR="$(mktemp -d -q --tmpdir "installosmvimemu.XXXXXX")"
1434 trap 'rm -rf "${EMUTEMPDIR}"' EXIT
1435 # install prerequisites (OVS is a must for the emulator to work)
1436 sudo apt-get install openvswitch-switch
1437 # clone vim-emu repository (attention: branch is currently master only)
1438 echo "Cloning vim-emu repository ..."
1439 git clone https://osm.etsi.org/gerrit/osm/vim-emu.git $EMUTEMPDIR
1440 # build vim-emu docker
1441 echo "Building vim-emu Docker container..."
1442
1443 sg docker -c "docker build -t vim-emu-img -f $EMUTEMPDIR/Dockerfile --no-cache $EMUTEMPDIR/" || FATAL "cannot build vim-emu-img docker image"
1444 # start vim-emu container as daemon
1445 echo "Starting vim-emu Docker container 'vim-emu' ..."
1446 if [ -n "$INSTALL_LIGHTWEIGHT" ]; then
1447 # in lightweight mode, the emulator needs to be attached to netOSM
1448 sg docker -c "docker run --name vim-emu -t -d --restart always --privileged --pid='host' --network=net${OSM_STACK_NAME} -v /var/run/docker.sock:/var/run/docker.sock vim-emu-img python examples/osm_default_daemon_topology_2_pop.py"
1449 else
1450 # classic build mode
1451 sg docker -c "docker run --name vim-emu -t -d --restart always --privileged --pid='host' -v /var/run/docker.sock:/var/run/docker.sock vim-emu-img python examples/osm_default_daemon_topology_2_pop.py"
1452 fi
1453 echo "Waiting for 'vim-emu' container to start ..."
1454 sleep 5
1455 export VIMEMU_HOSTNAME=$(sg docker -c "docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' vim-emu")
1456 echo "vim-emu running at ${VIMEMU_HOSTNAME} ..."
1457 # print vim-emu connection info
1458 echo -e "\nYou might be interested in adding the following vim-emu env variables to your .bashrc file:"
1459 echo " export VIMEMU_HOSTNAME=${VIMEMU_HOSTNAME}"
1460 echo -e "To add the emulated VIM to OSM you should do:"
1461 echo " osm vim-create --name emu-vim1 --user username --password password --auth_url http://${VIMEMU_HOSTNAME}:6001/v2.0 --tenant tenantName --account_type openstack"
1462 }
1463
1464 function install_k8s_monitoring() {
1465 # install OSM monitoring
1466 $WORKDIR_SUDO chmod +x $OSM_DEVOPS/installers/k8s/*.sh
1467 $WORKDIR_SUDO $OSM_DEVOPS/installers/k8s/install_osm_k8s_monitoring.sh
1468 }
1469
1470 function uninstall_k8s_monitoring() {
1471 # uninstall OSM monitoring
1472 $WORKDIR_SUDO $OSM_DEVOPS/installers/k8s/uninstall_osm_k8s_monitoring.sh
1473 }
1474
1475 function dump_vars(){
1476 echo "DEVELOP=$DEVELOP"
1477 echo "INSTALL_FROM_SOURCE=$INSTALL_FROM_SOURCE"
1478 echo "UNINSTALL=$UNINSTALL"
1479 echo "UPDATE=$UPDATE"
1480 echo "RECONFIGURE=$RECONFIGURE"
1481 echo "TEST_INSTALLER=$TEST_INSTALLER"
1482 echo "INSTALL_VIMEMU=$INSTALL_VIMEMU"
1483 echo "INSTALL_PLA=$INSTALL_PLA"
1484 echo "INSTALL_LXD=$INSTALL_LXD"
1485 echo "INSTALL_LIGHTWEIGHT=$INSTALL_LIGHTWEIGHT"
1486 echo "INSTALL_ONLY=$INSTALL_ONLY"
1487 echo "INSTALL_ELK=$INSTALL_ELK"
1488 echo "INSTALL_NOCACHELXDIMAGES=$INSTALL_NOCACHELXDIMAGES"
1489 #echo "INSTALL_PERFMON=$INSTALL_PERFMON"
1490 echo "INSTALL_TO_OPENSTACK=$INSTALL_TO_OPENSTACK"
1491 echo "OPENSTACK_PUBLIC_NET_NAME=$OPENSTACK_PUBLIC_NET_NAME"
1492 echo "OPENSTACK_OPENRC_FILE_OR_CLOUD=$OPENSTACK_OPENRC_FILE_OR_CLOUD"
1493 echo "OPENSTACK_ATTACH_VOLUME=$OPENSTACK_ATTACH_VOLUME"
1494 echo "OPENSTACK_SSH_KEY_FILE"="$OPENSTACK_SSH_KEY_FILE"
1495 echo "OPENSTACK_USERDATA_FILE"="$OPENSTACK_USERDATA_FILE"
1496 echo "OPENSTACK_VM_NAME"="$OPENSTACK_VM_NAME"
1497 echo "INSTALL_K8S_MONITOR=$INSTALL_K8S_MONITOR"
1498 echo "TO_REBUILD=$TO_REBUILD"
1499 echo "INSTALL_NOLXD=$INSTALL_NOLXD"
1500 echo "INSTALL_NODOCKER=$INSTALL_NODOCKER"
1501 echo "INSTALL_NOJUJU=$INSTALL_NOJUJU"
1502 echo "RELEASE=$RELEASE"
1503 echo "REPOSITORY=$REPOSITORY"
1504 echo "REPOSITORY_BASE=$REPOSITORY_BASE"
1505 echo "REPOSITORY_KEY=$REPOSITORY_KEY"
1506 echo "OSM_DEVOPS=$OSM_DEVOPS"
1507 echo "OSM_VCA_HOST=$OSM_VCA_HOST"
1508 echo "OSM_VCA_SECRET=$OSM_VCA_SECRET"
1509 echo "OSM_VCA_PUBKEY=$OSM_VCA_PUBKEY"
1510 echo "NO_HOST_PORTS=$NO_HOST_PORTS"
1511 echo "DOCKER_NOBUILD=$DOCKER_NOBUILD"
1512 echo "WORKDIR_SUDO=$WORKDIR_SUDO"
1513 echo "OSM_WORK_DIR=$OSM_WORK_DIR"
1514 echo "OSM_DOCKER_TAG=$OSM_DOCKER_TAG"
1515 echo "DOCKER_USER=$DOCKER_USER"
1516 echo "OSM_STACK_NAME=$OSM_STACK_NAME"
1517 echo "PULL_IMAGES=$PULL_IMAGES"
1518 echo "KUBERNETES=$KUBERNETES"
1519 echo "DOCKER_REGISTRY_URL=$DOCKER_REGISTRY_URL"
1520 echo "DOCKER_PROXY_URL=$DOCKER_PROXY_URL"
1521 echo "SHOWOPTS=$SHOWOPTS"
1522 echo "Install from specific refspec (-b): $COMMIT_ID"
1523 }
1524
1525 function track(){
1526 ctime=`date +%s`
1527 duration=$((ctime - SESSION_ID))
1528 url="http://www.woopra.com/track/ce?project=osm.etsi.org&cookie=${SESSION_ID}"
1529 #url="${url}&ce_campaign_name=${CAMPAIGN_NAME}"
1530 event_name="bin"
1531 [ -z "$INSTALL_LIGHTWEIGHT" ] && [ -n "$INSTALL_FROM_SOURCE" ] && event_name="binsrc"
1532 [ -z "$INSTALL_LIGHTWEIGHT" ] && [ -n "$INSTALL_FROM_LXDIMAGES" ] && event_name="lxd"
1533 [ -n "$INSTALL_LIGHTWEIGHT" ] && event_name="lw"
1534 event_name="${event_name}_$1"
1535 url="${url}&event=${event_name}&ce_duration=${duration}"
1536 wget -q -O /dev/null $url
1537 }
1538
1539 function parse_docker_registry_url() {
1540 DOCKER_REGISTRY_USER=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[1]}')
1541 DOCKER_REGISTRY_PASSWORD=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); split(a[1],b,":"); print b[2]}')
1542 DOCKER_REGISTRY_URL=$(echo "$DOCKER_REGISTRY_URL" | awk '{split($1,a,"@"); print a[2]}')
1543 }
1544
1545 JUJU_VERSION=2.9
1546 JUJU_AGENT_VERSION=2.9.9
1547 UNINSTALL=""
1548 DEVELOP=""
1549 UPDATE=""
1550 RECONFIGURE=""
1551 TEST_INSTALLER=""
1552 INSTALL_LXD=""
1553 SHOWOPTS=""
1554 COMMIT_ID=""
1555 ASSUME_YES=""
1556 INSTALL_FROM_SOURCE=""
1557 RELEASE="ReleaseTEN"
1558 REPOSITORY="stable"
1559 INSTALL_VIMEMU=""
1560 INSTALL_PLA=""
1561 LXD_REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/lxd"
1562 LXD_REPOSITORY_PATH=""
1563 INSTALL_LIGHTWEIGHT="y"
1564 INSTALL_TO_OPENSTACK=""
1565 OPENSTACK_OPENRC_FILE_OR_CLOUD=""
1566 OPENSTACK_PUBLIC_NET_NAME=""
1567 OPENSTACK_ATTACH_VOLUME="false"
1568 OPENSTACK_SSH_KEY_FILE=""
1569 OPENSTACK_USERDATA_FILE=""
1570 OPENSTACK_VM_NAME="server-osm"
1571 OPENSTACK_PYTHON_VENV="$HOME/.virtual-envs/osm"
1572 INSTALL_ONLY=""
1573 INSTALL_ELK=""
1574 TO_REBUILD=""
1575 INSTALL_NOLXD=""
1576 INSTALL_NODOCKER=""
1577 INSTALL_NOJUJU=""
1578 KUBERNETES="y"
1579 INSTALL_K8S_MONITOR=""
1580 INSTALL_NOHOSTCLIENT=""
1581 INSTALL_NOCACHELXDIMAGES=""
1582 SESSION_ID=`date +%s`
1583 OSM_DEVOPS=
1584 OSM_VCA_HOST=
1585 OSM_VCA_SECRET=
1586 OSM_VCA_PUBKEY=
1587 OSM_VCA_CLOUDNAME="localhost"
1588 OSM_VCA_K8S_CLOUDNAME="k8scloud"
1589 OSM_STACK_NAME=osm
1590 NO_HOST_PORTS=""
1591 DOCKER_NOBUILD=""
1592 REPOSITORY_KEY="OSM%20ETSI%20Release%20Key.gpg"
1593 REPOSITORY_BASE="https://osm-download.etsi.org/repository/osm/debian"
1594 WORKDIR_SUDO=sudo
1595 OSM_WORK_DIR="/etc/osm"
1596 OSM_DOCKER_WORK_DIR="/etc/osm/docker"
1597 OSM_K8S_WORK_DIR="${OSM_DOCKER_WORK_DIR}/osm_pods"
1598 OSM_HOST_VOL="/var/lib/osm"
1599 OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
1600 OSM_DOCKER_TAG=latest
1601 DOCKER_USER=opensourcemano
1602 PULL_IMAGES="y"
1603 KAFKA_TAG=2.11-1.0.2
1604 PROMETHEUS_TAG=v2.4.3
1605 GRAFANA_TAG=latest
1606 PROMETHEUS_NODE_EXPORTER_TAG=0.18.1
1607 PROMETHEUS_CADVISOR_TAG=latest
1608 KEYSTONEDB_TAG=10
1609 OSM_DATABASE_COMMONKEY=
1610 ELASTIC_VERSION=6.4.2
1611 ELASTIC_CURATOR_VERSION=5.5.4
1612 POD_NETWORK_CIDR=10.244.0.0/16
1613 K8S_MANIFEST_DIR="/etc/kubernetes/manifests"
1614 RE_CHECK='^[a-z0-9]([-a-z0-9]*[a-z0-9])?$'
1615 DOCKER_REGISTRY_URL=
1616 DOCKER_PROXY_URL=
1617 MODULE_DOCKER_TAG=
1618
1619 while getopts ":b:r:c:n:k:u:R:D:o:O:m:N:H:S:s:w:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
1620 case "${o}" in
1621 b)
1622 COMMIT_ID=${OPTARG}
1623 PULL_IMAGES=""
1624 ;;
1625 r)
1626 REPOSITORY="${OPTARG}"
1627 REPO_ARGS+=(-r "$REPOSITORY")
1628 ;;
1629 c)
1630 [ "${OPTARG}" == "swarm" ] && KUBERNETES="" && REPO_ARGS+=(-c "${OPTARG}") && continue
1631 [ "${OPTARG}" == "k8s" ] && KUBERNETES="y" && continue
1632 echo -e "Invalid argument for -i : ' $OPTARG'\n" >&2
1633 usage && exit 1
1634 ;;
1635 k)
1636 REPOSITORY_KEY="${OPTARG}"
1637 REPO_ARGS+=(-k "$REPOSITORY_KEY")
1638 ;;
1639 u)
1640 REPOSITORY_BASE="${OPTARG}"
1641 REPO_ARGS+=(-u "$REPOSITORY_BASE")
1642 ;;
1643 R)
1644 RELEASE="${OPTARG}"
1645 REPO_ARGS+=(-R "$RELEASE")
1646 ;;
1647 D)
1648 OSM_DEVOPS="${OPTARG}"
1649 ;;
1650 o)
1651 INSTALL_ONLY="y"
1652 [ "${OPTARG}" == "vimemu" ] && INSTALL_VIMEMU="y" && continue
1653 [ "${OPTARG}" == "elk_stack" ] && INSTALL_ELK="y" && continue
1654 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
1655 ;;
1656 O)
1657 INSTALL_TO_OPENSTACK="y"
1658 if [ -n "${OPTARG}" ]; then
1659 OPENSTACK_OPENRC_FILE_OR_CLOUD="${OPTARG}"
1660 else
1661 echo -e "Invalid argument for -O : ' $OPTARG'\n" >&2
1662 usage && exit 1
1663 fi
1664 ;;
1665 f)
1666 OPENSTACK_SSH_KEY_FILE="${OPTARG}"
1667 ;;
1668 F)
1669 OPENSTACK_USERDATA_FILE="${OPTARG}"
1670 ;;
1671 N)
1672 OPENSTACK_PUBLIC_NET_NAME="${OPTARG}"
1673 ;;
1674 m)
1675 [ "${OPTARG}" == "NG-UI" ] && TO_REBUILD="$TO_REBUILD NG-UI" && continue
1676 [ "${OPTARG}" == "NBI" ] && TO_REBUILD="$TO_REBUILD NBI" && continue
1677 [ "${OPTARG}" == "LCM" ] && TO_REBUILD="$TO_REBUILD LCM" && continue
1678 [ "${OPTARG}" == "RO" ] && TO_REBUILD="$TO_REBUILD RO" && continue
1679 [ "${OPTARG}" == "MON" ] && TO_REBUILD="$TO_REBUILD MON" && continue
1680 [ "${OPTARG}" == "POL" ] && TO_REBUILD="$TO_REBUILD POL" && continue
1681 [ "${OPTARG}" == "PLA" ] && TO_REBUILD="$TO_REBUILD PLA" && continue
1682 [ "${OPTARG}" == "osmclient" ] && TO_REBUILD="$TO_REBUILD osmclient" && continue
1683 [ "${OPTARG}" == "KAFKA" ] && TO_REBUILD="$TO_REBUILD KAFKA" && continue
1684 [ "${OPTARG}" == "MONGO" ] && TO_REBUILD="$TO_REBUILD MONGO" && continue
1685 [ "${OPTARG}" == "PROMETHEUS" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS" && continue
1686 [ "${OPTARG}" == "PROMETHEUS-CADVISOR" ] && TO_REBUILD="$TO_REBUILD PROMETHEUS-CADVISOR" && continue
1687 [ "${OPTARG}" == "KEYSTONE-DB" ] && TO_REBUILD="$TO_REBUILD KEYSTONE-DB" && continue
1688 [ "${OPTARG}" == "GRAFANA" ] && TO_REBUILD="$TO_REBUILD GRAFANA" && continue
1689 [ "${OPTARG}" == "NONE" ] && TO_REBUILD="$TO_REBUILD NONE" && continue
1690 ;;
1691 H)
1692 OSM_VCA_HOST="${OPTARG}"
1693 ;;
1694 S)
1695 OSM_VCA_SECRET="${OPTARG}"
1696 ;;
1697 s)
1698 OSM_STACK_NAME="${OPTARG}" && [ -n "$KUBERNETES" ] && [[ ! "${OPTARG}" =~ $RE_CHECK ]] && echo "Namespace $OPTARG is invalid. Regex used for validation is $RE_CHECK" && exit 0
1699 ;;
1700 w)
1701 # when specifying workdir, do not use sudo for access
1702 WORKDIR_SUDO=
1703 OSM_WORK_DIR="${OPTARG}"
1704 ;;
1705 t)
1706 OSM_DOCKER_TAG="${OPTARG}"
1707 REPO_ARGS+=(-t "$OSM_DOCKER_TAG")
1708 ;;
1709 U)
1710 DOCKER_USER="${OPTARG}"
1711 ;;
1712 P)
1713 OSM_VCA_PUBKEY=$(cat ${OPTARG})
1714 ;;
1715 A)
1716 OSM_VCA_APIPROXY="${OPTARG}"
1717 ;;
1718 l)
1719 LXD_CLOUD_FILE="${OPTARG}"
1720 ;;
1721 L)
1722 LXD_CRED_FILE="${OPTARG}"
1723 ;;
1724 K)
1725 CONTROLLER_NAME="${OPTARG}"
1726 ;;
1727 d)
1728 DOCKER_REGISTRY_URL="${OPTARG}"
1729 ;;
1730 p)
1731 DOCKER_PROXY_URL="${OPTARG}"
1732 ;;
1733 T)
1734 MODULE_DOCKER_TAG="${OPTARG}"
1735 ;;
1736 -)
1737 [ "${OPTARG}" == "help" ] && usage && exit 0
1738 [ "${OPTARG}" == "source" ] && INSTALL_FROM_SOURCE="y" && PULL_IMAGES="" && continue
1739 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
1740 [ "${OPTARG}" == "uninstall" ] && UNINSTALL="y" && continue
1741 [ "${OPTARG}" == "update" ] && UPDATE="y" && continue
1742 [ "${OPTARG}" == "reconfigure" ] && RECONFIGURE="y" && continue
1743 [ "${OPTARG}" == "test" ] && TEST_INSTALLER="y" && continue
1744 [ "${OPTARG}" == "lxdinstall" ] && INSTALL_LXD="y" && continue
1745 [ "${OPTARG}" == "nolxd" ] && INSTALL_NOLXD="y" && continue
1746 [ "${OPTARG}" == "nodocker" ] && INSTALL_NODOCKER="y" && continue
1747 [ "${OPTARG}" == "lightweight" ] && INSTALL_LIGHTWEIGHT="y" && continue
1748 [ "${OPTARG}" == "vimemu" ] && INSTALL_VIMEMU="y" && continue
1749 [ "${OPTARG}" == "elk_stack" ] && INSTALL_ELK="y" && continue
1750 [ "${OPTARG}" == "showopts" ] && SHOWOPTS="y" && continue
1751 [ "${OPTARG}" == "nohostports" ] && NO_HOST_PORTS="y" && continue
1752 [ "${OPTARG}" == "nojuju" ] && INSTALL_NOJUJU="y" && continue
1753 [ "${OPTARG}" == "nodockerbuild" ] && DOCKER_NOBUILD="y" && continue
1754 [ "${OPTARG}" == "nohostclient" ] && INSTALL_NOHOSTCLIENT="y" && continue
1755 [ "${OPTARG}" == "pullimages" ] && continue
1756 [ "${OPTARG}" == "k8s_monitor" ] && INSTALL_K8S_MONITOR="y" && continue
1757 [ "${OPTARG}" == "charmed" ] && CHARMED="y" && continue
1758 [ "${OPTARG}" == "bundle" ] && continue
1759 [ "${OPTARG}" == "k8s" ] && continue
1760 [ "${OPTARG}" == "lxd" ] && continue
1761 [ "${OPTARG}" == "lxd-cred" ] && continue
1762 [ "${OPTARG}" == "microstack" ] && continue
1763 [ "${OPTARG}" == "overlay" ] && continue
1764 [ "${OPTARG}" == "only-vca" ] && continue
1765 [ "${OPTARG}" == "vca" ] && continue
1766 [ "${OPTARG}" == "ha" ] && continue
1767 [ "${OPTARG}" == "tag" ] && continue
1768 [ "${OPTARG}" == "registry" ] && continue
1769 [ "${OPTARG}" == "pla" ] && INSTALL_PLA="y" && continue
1770 [ "${OPTARG}" == "volume" ] && OPENSTACK_ATTACH_VOLUME="true" && continue
1771 [ "${OPTARG}" == "nocachelxdimages" ] && INSTALL_NOCACHELXDIMAGES="y" && continue
1772 echo -e "Invalid option: '--$OPTARG'\n" >&2
1773 usage && exit 1
1774 ;;
1775 :)
1776 echo "Option -$OPTARG requires an argument" >&2
1777 usage && exit 1
1778 ;;
1779 \?)
1780 echo -e "Invalid option: '-$OPTARG'\n" >&2
1781 usage && exit 1
1782 ;;
1783 h)
1784 usage && exit 0
1785 ;;
1786 y)
1787 ASSUME_YES="y"
1788 ;;
1789 *)
1790 usage && exit 1
1791 ;;
1792 esac
1793 done
1794
1795 [ -n "$DOCKER_REGISTRY_URL" ] && parse_docker_registry_url
1796 [ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" != " NONE" ] && echo $TO_REBUILD | grep -q NONE && FATAL "Incompatible option: -m NONE cannot be used with other -m options"
1797 [ -n "$TO_REBUILD" ] && [ "$TO_REBUILD" == " PLA" ] && [ -z "$INSTALL_PLA" ] && FATAL "Incompatible option: -m PLA cannot be used without --pla option"
1798
1799 if [ -n "$SHOWOPTS" ]; then
1800 dump_vars
1801 exit 0
1802 fi
1803
1804 if [ -n "$CHARMED" ]; then
1805 if [ -n "$UNINSTALL" ]; then
1806 ${OSM_DEVOPS}/installers/charmed_uninstall.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"
1807 else
1808 ${OSM_DEVOPS}/installers/charmed_install.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"
1809 fi
1810
1811 exit 0
1812 fi
1813
1814 # if develop, we force master
1815 [ -z "$COMMIT_ID" ] && [ -n "$DEVELOP" ] && COMMIT_ID="master"
1816
1817 need_packages="git wget curl tar"
1818
1819 [ -n "$INSTALL_TO_OPENSTACK" ] && install_to_openstack $OPENSTACK_OPENRC_FILE_OR_CLOUD $OPENSTACK_PUBLIC_NET_NAME $OPENSTACK_ATTACH_VOLUME && echo -e "\nDONE" && exit 0
1820
1821 echo -e "Checking required packages: $need_packages"
1822 dpkg -l $need_packages &>/dev/null \
1823 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
1824 || sudo apt-get update \
1825 || FATAL "failed to run apt-get update"
1826 dpkg -l $need_packages &>/dev/null \
1827 || ! echo -e "Installing $need_packages requires root privileges." \
1828 || sudo apt-get install -y $need_packages \
1829 || FATAL "failed to install $need_packages"
1830 sudo snap install jq
1831 if [ -z "$OSM_DEVOPS" ]; then
1832 if [ -n "$TEST_INSTALLER" ]; then
1833 echo -e "\nUsing local devops repo for OSM installation"
1834 OSM_DEVOPS="$(dirname $(realpath $(dirname $0)))"
1835 else
1836 echo -e "\nCreating temporary dir for OSM installation"
1837 OSM_DEVOPS="$(mktemp -d -q --tmpdir "installosm.XXXXXX")"
1838 trap 'rm -rf "$OSM_DEVOPS"' EXIT
1839
1840 git clone https://osm.etsi.org/gerrit/osm/devops.git $OSM_DEVOPS
1841
1842 if [ -z "$COMMIT_ID" ]; then
1843 echo -e "\nGuessing the current stable release"
1844 LATEST_STABLE_DEVOPS=`git -C $OSM_DEVOPS tag -l v[0-9].* | sort -V | tail -n1`
1845 [ -z "$LATEST_STABLE_DEVOPS" ] && echo "Could not find the current latest stable release" && exit 0
1846
1847 echo "Latest tag in devops repo: $LATEST_STABLE_DEVOPS"
1848 COMMIT_ID="tags/$LATEST_STABLE_DEVOPS"
1849 else
1850 echo -e "\nDEVOPS Using commit $COMMIT_ID"
1851 fi
1852 git -C $OSM_DEVOPS checkout $COMMIT_ID
1853 fi
1854 fi
1855
1856 . $OSM_DEVOPS/common/all_funcs
1857
1858 [ "${OSM_STACK_NAME}" == "osm" ] || OSM_DOCKER_WORK_DIR="$OSM_WORK_DIR/stack/$OSM_STACK_NAME"
1859 [ -n "$KUBERNETES" ] && OSM_K8S_WORK_DIR="$OSM_DOCKER_WORK_DIR/osm_pods" && OSM_NAMESPACE_VOL="${OSM_HOST_VOL}/${OSM_STACK_NAME}"
1860 [ -n "$INSTALL_LIGHTWEIGHT" ] && [ -n "$UNINSTALL" ] && uninstall_lightweight && echo -e "\nDONE" && exit 0
1861 [ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_ELK" ] && deploy_elk
1862 #[ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_PERFMON" ] && deploy_perfmon
1863 [ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_VIMEMU" ] && install_vimemu
1864 [ -n "$INSTALL_ONLY" ] && [ -n "$INSTALL_K8S_MONITOR" ] && install_k8s_monitoring
1865 [ -n "$INSTALL_ONLY" ] && echo -e "\nDONE" && exit 0
1866
1867 #Installation starts here
1868 wget -q -O- https://osm-download.etsi.org/ftp/osm-10.0-ten/README.txt &> /dev/null
1869 track start
1870
1871 [ -n "$INSTALL_LIGHTWEIGHT" ] && install_lightweight && echo -e "\nDONE" && exit 0
1872 echo -e "\nInstalling OSM from refspec: $COMMIT_ID"
1873 if [ -n "$INSTALL_FROM_SOURCE" ] && [ -z "$ASSUME_YES" ]; then
1874 ! ask_user "The installation will take about 75-90 minutes. Continue (Y/n)? " y && echo "Cancelled!" && exit 1
1875 fi
1876
1877 echo -e "Checking required packages: lxd"
1878 lxd --version &>/dev/null || FATAL "lxd not present, exiting."
1879 [ -n "$INSTALL_LXD" ] && echo -e "\nInstalling and configuring lxd" && install_lxd
1880
1881 # use local devops for containers
1882 export OSM_USE_LOCAL_DEVOPS=true
1883
1884 #Install osmclient
1885
1886 #Install vim-emu (optional)
1887 [ -n "$INSTALL_VIMEMU" ] && install_docker_ce && install_vimemu
1888
1889 wget -q -O- https://osm-download.etsi.org/ftp/osm-10.0-ten/README2.txt &> /dev/null
1890 track end
1891 echo -e "\nDONE"